## linkchecker 9.4.0

=== Makefile ===
# This Makefile is only used by developers.
PYVER:=2.7
PYTHON?=python$(PYVER)
VERSION:=$(shell $(PYTHON) setup.py --version)
PLATFORM:=$(shell $(PYTHON) -c "from __future__ import print_function; from distutils.util import get_platform; print(get_platform())")
APPNAME:=$(shell $(PYTHON) setup.py --name)
AUTHOR:=$(shell $(PYTHON) setup.py --author)
MAINTAINER:=$(shell $(PYTHON) setup.py --maintainer)
LAPPNAME:=$(shell echo $(APPNAME)|tr "[A-Z]" "[a-z]")
ARCHIVE_SOURCE_EXT:=gz
ARCHIVE_SOURCE:=$(APPNAME)-$(VERSION).tar.$(ARCHIVE_SOURCE_EXT)
GITUSER:=wummel
GITREPO:=$(LAPPNAME)
HOMEPAGE:=$(HOME)/public_html/$(LAPPNAME)-webpage.git
WEB_META:=doc/web/app.yaml
DEBUILDDIR:=$(HOME)/projects/debian/official
DEBORIGFILE:=$(DEBUILDDIR)/$(LAPPNAME)_$(VERSION).orig.tar.$(ARCHIVE_SOURCE_EXT)
DEBPACKAGEDIR:=$(DEBUILDDIR)/$(APPNAME)-$(VERSION)
FILESCHECK_URL:=http://localhost/~calvin/
SRCDIR:=${HOME}/src
PY_FILES_DIRS:=linkcheck tests *.py linkchecker cgi-bin config doc/examples scripts
MYPY_FILES_DIRS:=linkcheck/HtmlParser linkcheck/checker \
	  linkcheck/cache linkcheck/configuration linkcheck/director \
	  linkcheck/htmlutil linkcheck/logger linkcheck/network \
	  linkcheck/bookmarks linkcheck/plugins linkcheck/parser \
	  $(filter-out %2.py,$(wildcard linkcheck/*.py)) \
	  cgi-bin/lc.wsgi \
	  linkchecker \
	  *.py

TESTS ?= tests
# set test options, eg. to "--verbose"
TESTOPTS=
PAGER ?= less
# options to run the pep8 utility
PEP8OPTS:=--repeat --ignore=E211,E501,E225,E301,E302,E241 \
   --exclude="gzip2.py,httplib2.py,robotparser2.py"
PY2APPOPTS ?=
ifeq ($(shell uname),Darwin)
  CHMODMINUSMINUS:=
else
  CHMODMINUSMINUS:=--
endif
# Pytest options:
# - use multiple processes
# - write test results in file
PYTESTOPTS:=-n 4 --resultlog=testresults.txt


all:
	@echo "Read the file doc/install.txt to see how to build and install this package."

clean:
	-$(PYTHON) setup.py clean --all
	rm -f $(LAPPNAME)-out.* *-stamp*
	$(MAKE) -C linkcheck/HtmlParser clean
	rm -f linkcheck/network/_network*.so
	find . -name '*.py[co]' -exec rm -f {} \;
	find . -name '*.bak' -exec rm -f {} \;
	find . -depth -name '__pycache__' -exec rm -rf {} \;

distclean: clean
	rm -rf build dist $(APPNAME).egg-info
	rm -f _$(APPNAME)_configdata.py MANIFEST Packages.gz
# clean aborted dist builds and -out files
	rm -f $(LAPPNAME)-out* $(LAPPNAME).prof
	rm -f alexa*.log testresults.txt
	rm -rf $(APPNAME)-$(VERSION)
	rm -rf coverage dist-stamp python-build-stamp*

MANIFEST: MANIFEST.in setup.py
	$(PYTHON) setup.py sdist --manifest-only

locale:
	$(MAKE) -C po

# to build in the current directory
localbuild: MANIFEST locale
	$(MAKE) -C linkcheck/HtmlParser
	$(PYTHON) setup.py build
	cp -f build/lib.$(PLATFORM)-$(PYVER)*/linkcheck/HtmlParser/htmlsax*.so linkcheck/HtmlParser
	cp -f build/lib.$(PLATFORM)-$(PYVER)*/linkcheck/network/_network*.so linkcheck/network

release: distclean releasecheck filescheck
	$(MAKE) dist sign register upload homepage tag changelog deb

tag:
	git tag upstream/$(VERSION)
	git push --tags origin upstream/$(VERSION)

upload:
	twine upload dist/$(ARCHIVE_SOURCE) dist/$(ARCHIVE_SOURCE).asc


homepage:
# update metadata
	@echo "version: \"$(VERSION)\"" > $(WEB_META)
	@echo "name: \"$(APPNAME)\"" >> $(WEB_META)
	@echo "lname: \"$(LAPPNAME)\"" >> $(WEB_META)
	@echo "maintainer: \"$(MAINTAINER)\"" >> $(WEB_META)
	@echo "author: \"$(AUTHOR)\"" >> $(WEB_META)
	git add $(WEBMETA)
	-git commit -m "Updated webpage meta info"
# update documentation and man pages
	$(MAKE) -C doc man
	$(MAKE) -C doc/web release

register:
	@echo "Register at Python Package Index..."
	$(PYTHON) setup.py register
	@echo "done."

deb:
# build a debian package
	[ -f $(DEBORIGFILE) ] || cp dist/$(ARCHIVE_SOURCE) $(DEBORIGFILE)
	sed -i -e 's/VERSION_$(LAPPNAME):=.*/VERSION_$(LAPPNAME):=$(VERSION)/' $(DEBUILDDIR)/$(LAPPNAME).mak
	[ -d $(DEBPACKAGEDIR) ] || (cd $(DEBUILDDIR); \
	  patool extract $(DEBORIGFILE); \
	  cd $(CURDIR); \
	  git checkout debian; \
	  cp -r debian $(DEBPACKAGEDIR); \
	  rm -f $(DEBPACKAGEDIR)/debian/.gitignore; \
	  git checkout master)
	$(MAKE) -C $(DEBUILDDIR) $(LAPPNAME)_clean $(LAPPNAME)

chmod:
	-chmod -R a+rX,u+w,go-w $(CHMODMINUSMINUS) *
	find . -type d -exec chmod 755 {} \;

dist: locale MANIFEST chmod
	rm -f dist/$(ARCHIVE_SOURCE)
	$(PYTHON) setup.py sdist --formats=tar
	gzip --best dist/$(APPNAME)-$(VERSION).tar

# The check programs used here are mostly local scripts on my private system.
# So for other developers there is no need to execute this target.
check:
	check-copyright
	check-pofiles -v
	py-tabdaddy $(MYPY_FILES_DIRS)
	py-unittest2-compat tests/
	$(MAKE) -C doc check
	$(MAKE) doccheck
	$(MAKE) pyflakes

doccheck:
	py-check-docstrings --force $(MYPY_FILES_DIRS)

filescheck: localbuild
	for out in text html gml sql csv xml gxml dot sitemap; do \
	  ./$(LAPPNAME) -o$$out -F$$out --complete -r1 -C $(FILESCHECK_URL) || exit 1; \
	done

update-copyright:
	update-copyright --holder="Bastian Kleineidam" $(PY_FILES_DIRS)

releasecheck: check
	@if egrep -i "xx\.|xxxx|\.xx" doc/changelog.txt > /dev/null; then \
	  echo "Could not release: edit doc/changelog.txt release date"; false; \
	fi
	$(PYTHON) setup.py check --restructuredtext

sign:
	for f in $(shell find dist -name *.$(ARCHIVE_SOURCE_EXT) -o -name *.exe -o -name *.zip -o -name *.dmg); do \
	  [ -f $${f}.asc ] || gpg --detach-sign --armor $$f; \
	done

test:	localbuild
	env LANG=en_US.utf-8 $(PYTHON) -m pytest $(PYTESTOPTS) $(TESTOPTS) $(TESTS)

pyflakes:
	pyflakes $(PY_FILES_DIRS) 2>&1 | \
          grep -v "local variable 'dummy' is assigned to but never used" | \
          grep -v -E "'(biplist|setuptools|win32com|find_executable|parse_sitemap|parse_sitemapindex|parse_bookmark_data|parse_bookmark_file|wsgiref|pyftpdlib|linkchecker_rc)' imported but unused" | \
          grep -v "undefined name '_'" | \
	  grep -v "undefined name '_n'" | cat

pep8:
	pep8 $(PEP8OPTS) $(PY_FILES_DIRS)

# Compare custom Python files with the originals
diff:
	@for f in gzip robotparser; do \
	  echo "Comparing $${f}.py"; \
	  diff -u linkcheck/$${f}2.py $(SRCDIR)/cpython.hg/Lib/$${f}.py | $(PAGER); \
	done
	@diff -u linkcheck/better_exchook.py $(SRCDIR)/py_better_exchook.git/better_exchook.py

changelog:
	github-changelog $(DRYRUN) $(GITUSER) $(GITREPO) doc/changelog.txt

count:
	@sloccount linkchecker linkcheck tests

# run eclipse ide
ide:
	eclipse -data $(CURDIR)/..

.PHONY: test changelog count pyflakes ide login upload all clean distclean
.PHONY: pep8 cleandeb locale localbuild deb diff dnsdiff sign
.PHONY: filescheck update-copyright releasecheck check register announce
.PHONY: chmod dist release homepage

=== requirements.txt ===
# required:
requests<2.15,>=2.2
pyxdg
dnspython
# optional:
argcomplete

=== doc/Makefile ===
HTMLDIR:=web/media
MANHTMLFILES:= \
	$(HTMLDIR)/man1/linkchecker.1.html \
	$(HTMLDIR)/man5/linkcheckerrc.5.html

MANFILES:=linkchecker.1 linkcheckerrc.5
LOCALES:=en de

all:

po4a:
	po4a --localized-charset=UTF-8 po4a.conf

man:	$(MANHTMLFILES)

$(HTMLDIR)/man1/linkchecker.1.html: en/linkchecker.1 linkchecker.1.html.diff
	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' | sed 's@/:@/@g' > $@
	patch --no-backup-if-mismatch --quiet $@ linkchecker.1.html.diff

$(HTMLDIR)/man5/linkcheckerrc.5.html: en/linkcheckerrc.5 linkcheckerrc.5.html.diff
	man2html -r $< | tail -n +2 | sed 's/Time:.*//g' | sed 's@/:@/@g' > $@
	patch --no-backup-if-mismatch --quiet $@ linkcheckerrc.5.html.diff

# check all makefiles for formatting warnings
check:
	@t=$(shell tempfile); \
	for loc in $(LOCALES); do \
	  for manfile in $(MANFILES); do \
	    echo "Checking $$loc/$$manfile"; \
	    LC_ALL=en_US.UTF-8 MANWIDTH=80 man --warnings -E UTF-8 -l $$loc/$$manfile > /dev/null 2>$$t ; \
	    if [ -s $$t ]; then cat $$t; exit 1; fi; \
	  done; \
	done

.PHONY: po4a man check

=== po/Makefile ===
XGETTEXT := xgettext
MSGFMT := msgfmt
MSGMERGE := msgmerge
POSOURCES = $(shell find ../linkcheck -name \*.py) \
	../linkchecker /usr/lib/python2.7/argparse.py
LDIR = ../share/locale
PACKAGE = linkchecker
TEMPLATE = $(PACKAGE).pot
MYMAIL := bastian.kleineidam@web.de
LFILE = LC_MESSAGES/$(PACKAGE).mo
# defined language (add new languages here)
LANGUAGES = de fr es
MOFILES = $(wildcard *.po)

all:	$(MOFILES)

%.mo:	%.po
	$(MSGFMT) -c --statistics -o $@ $<

%.po:	$(TEMPLATE)
	$(MSGMERGE) -U --suffix=.bak $@ $<

template: $(TEMPLATE)
$(TEMPLATE): $(POSOURCES)
	$(XGETTEXT) -w 80 --default-domain=$(PACKAGE) --language=Python \
	  --copyright-holder="Bastian Kleineidam <$(MYMAIL)>" \
	  --msgid-bugs-address=$(MYMAIL) -o $(TEMPLATE) \
	  --keyword=_n:1,2 $(POSOURCES)

%.mo:	%.po
	if [ ! -d $(LDIR)/$*/LC_MESSAGES ]; then \
	  mkdir -p $(LDIR)/$*/LC_MESSAGES; \
	fi
	$(MSGFMT) -c --statistics -o $(LDIR)/$*/$(LFILE) $<

clean:
	@for f in $(LANGUAGES); do rm -f $(LDIR)/$$f/$(LFILE); done
	rm -f *.mo *.bak

.PHONY: clean

=== linkcheck/HtmlParser/Makefile ===
# This HTML parser needs flex >= 2.5.xx from http://lex.sf.net/ for
# reentrant bison parser support and uses features of bison >= 3.0.x
LEX = flex
YACC = bison
PYINCLUDE=-I/usr/include/python2.7

all: htmllex.c htmlparse.c

htmlsax.so: htmllex.o htmlparse.o s_util.o
	gcc -pthread -shared $^ -o htmlsax.so

%.o:	%.c
	gcc -g -std=c99 -O3 -Wall -pedantic -Wstrict-prototypes -fPIC -I. $(PYINCLUDE) -c $< -o $@

htmlparse.h htmlparse.c:	htmlparse.y htmlsax.h
	$(YACC) --output=htmlparse.c htmlparse.y

htmllex.l:	htmlparse.h

htmllex.c:	htmllex.l htmlsax.h
	$(LEX) htmllex.l
	awk -f fixincludes.awk htmllex.c > htmllex.c.fixed; mv -f htmllex.c.fixed htmllex.c

clean:
	rm -f *.o *.so *.pyc *.pyo *.output

distclean: clean
	rm -f htmlparse.c htmlparse.h htmllex.c

=== debian/changelog ===
linkchecker (9.4.0-2ubuntu3) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:23:15 +0100

linkchecker (9.4.0-2ubuntu2) focal; urgency=medium

  * Don't hard-code python.
  * Use python2 in the build.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 10 Jan 2020 18:21:33 +0100

linkchecker (9.4.0-2build1) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:36:09 +0000

linkchecker (9.4.0-2) unstable; urgency=medium

  * add missing dependencies (Closes: #897462, #901780)
  * remove old apache2.2 compat shims (Closes: #775087)
  * remove .desktop file from commandline tool (Closes: #901782, #780488)
  * silence various lintian warnings:
    * follow apache policy more closely
    * rename apache config file
    * ignore false positives on old 2.2 apache config matches
    * removing old pycompat
    * clear out whitespace in changelog
    * update standards to 4.1.4
    * remove conflict with version from squeeze and earlier
    * reformat copyright file to comply with dep5
    * bump dh compat to 11 and fix docs install

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 21 Jun 2018 11:48:01 -0400

linkchecker (9.4.0-1) unstable; urgency=low

  [ Bastian Kleineidam ]
  * Remove build-depend on hardening-wrapper since the appropriate
    GCC environment vars are already set by dh_auto_* helpers.

  [ Antoine Beaupré ]
  * New upstream release (Closes: #847208, #878942)
  * Take over maintainership. Maintainer is part of the upstream GitHub
    organization that is trying to continue maintain the project while
    calvin@ is emeritus.
  * Add git-buildpackage configuration
  * Remove two patches factored in upstream
  * Add missing setuptools dependency
  * Remove the GUI binary package, split out upstream (Closes: #875032)
  * Update copyright file to follow upstream changes
  * Fix upstream urls to the new organization
  * Ignore files not packaged in upstream tarball
  * Disable manual .mo file install so that build works at all
  * Include cgi-bin readme to clarify web configuration (Closes: #775088)

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 11 Apr 2018 20:15:00 -0400

=== debian/control ===
Source: linkchecker
Section: web
Priority: optional
Maintainer: Antoine Beaupré <anarcat@debian.org>
Build-Depends: debhelper (>= 11),
               dh-python,
               python2,
               gettext,
               python-all-dev,
               python-requests (>= 2.2.1),
               python-setuptools,
               python-urllib3,
X-Python-Version: >= 2.7
Standards-Version: 4.1.4
Homepage: https://linkcheck.github.io/linkchecker/

Package: linkchecker
Architecture: any
Depends: python-requests (>= 2.2.1),
         python-urllib3,
         python-xdg,
         python-dnspython,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Provides: ${python:Provides}
Suggests: clamav-daemon,
          linkchecker-web,
          python-argcomplete,
          python-cssutils,
          python-gconf,
          python-geoip,
          python-meliae
Description: check websites and HTML documents for broken links
 Provides a command line program and web interface to check links
 of websites and HTML documents.
 Features:
  o recursive checking
  o multithreaded
  o output in colored or normal text, HTML, SQL, CSV, XML or a sitemap
    graph in different formats
  o HTTP/1.1, HTTPS, FTP, mailto:, news:, nntp:, Telnet and local file
    links support
  o restrict link checking with regular expression filters for URLs
  o proxy support
  o username/password authorization for HTTP, FTP and Telnet
  o robots.txt exclusion protocol support
  o Cookie support
  o i18n support
  o HTML and CSS syntax check
  o Antivirus check

Package: linkchecker-web
Architecture: all
Depends: linkchecker,
         ${misc:Depends},
         ${python:Depends}
Recommends: apache2 | httpd,
            libapache2-mod-wsgi | httpd-wsgi
Description: check websites and HTML documents for broken links (web client)
 Provides a web interface to check links of websites and HTML documents.
 Features:
  o recursive checking
  o multithreaded
  o HTTP/1.1, HTTPS, FTP, mailto:, news:, nntp:, Telnet and local file
    links support
  o proxy support
  o username/password authorization for HTTP, FTP and Telnet
  o robots.txt exclusion protocol support
  o i18n support

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_configure:
# make sure docs are generated and the manifest is built
	$(MAKE) locale
	python2 setup.py sdist --manifest-only

override_dh_auto_build:
# force usage of setup.py over Makefile
	dh_auto_build --buildsystem pybuild

override_dh_installchangelogs:
# install custom changelog
	dh_installchangelogs doc/changelog.txt


ROOTDIR=$(CURDIR)/debian/linkchecker
LOCALEDIR=$(ROOTDIR)/usr/share/locale
ETCDIR=$(ROOTDIR)/etc

ROOTDIRWEB=$(CURDIR)/debian/linkchecker-web
HTMLDIRWEB=$(ROOTDIRWEB)/usr/share/linkchecker/lconline
CGIDIRWEB=$(ROOTDIRWEB)/usr/lib/cgi-bin
ETCDIRWEB=$(ROOTDIRWEB)/etc

override_dh_auto_install-arch:
	dh_auto_install --buildsystem pybuild
# install bash_completion script
	install -m 644 config/linkchecker-completion $(ROOTDIR)/usr/share/bash-completion/completions/

override_dh_auto_install-indep:
	dh_auto_install --buildsystem pybuild
# install CGI files in web package
	install -m 644 cgi-bin/lconline/*.html $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.de $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.en $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.js $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.css $(HTMLDIRWEB)
	install -m 644 cgi-bin/lconline/*.ico $(HTMLDIRWEB)
	install -m 755 cgi-bin/lc.wsgi $(CGIDIRWEB)
# apache configuration
	install -m 644 config/linkchecker.apache2.conf $(ETCDIRWEB)/apache2/conf-available/linkchecker-web.conf

# clean generated files
override_dh_clean:
	dh_clean doc/html/*.qch doc/html/*.qhc _LinkChecker_configdata.py

# do not run test suite when building
override_dh_auto_test:

# use xz for debian binary package compression
override_dh_builddeb:
	dh_builddeb -- -Zxz

## linkchecker 10.0.0

=== debian/changelog ===
linkchecker (10.0.0-1) unstable; urgency=medium

  * fix syntax of lists (Closes: #935529)
  * new upstream release:
    * removes GUI support (Closes: #934458)
    * ported to Python 3 (Closes: #936950)
  * fix python3 dependencies (Closes: #953375)
  * remove last debian-specific patch, merged upstream

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 27 Jan 2021 15:16:44 -0500

=== debian/control ===
Source: linkchecker
Section: web
Priority: optional
Maintainer: Antoine Beaupré <anarcat@debian.org>
Build-Depends: debhelper (>= 11),
               dh-python,
               gettext,
               python3-all-dev,
               python3-requests (>= 2.2.1),
               python3-setuptools,
               python3-urllib3,
Standards-Version: 4.1.4
Homepage: https://linkcheck.github.io/linkchecker/

Package: linkchecker
Architecture: any
Depends: python3,
         python3-requests (>= 2.2.1),
         python3-urllib3,
         python3-xdg,
         python3-dnspython,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Suggests: clamav-daemon,
          linkchecker-web,
          python3-argcomplete,
          python3-cssutils,
          python3-gconf,
          python3-geoip,
          python3-meliae
Description: check websites and HTML documents for broken links
 Provides a command line program and web interface to check links
 of websites and HTML documents.
 Features:
  * recursive checking
  * multithreaded
  * output in colored or normal text, HTML, SQL, CSV, XML or a sitemap
    graph in different formats
  * HTTP/1.1, HTTPS, FTP, mailto:, news:, nntp:, Telnet and local file
    links support
  * restrict link checking with regular expression filters for URLs
  * proxy support
  * username/password authorization for HTTP, FTP and Telnet
  * robots.txt exclusion protocol support
  * Cookie support
  * i18n support
  * HTML and CSS syntax check
  * Antivirus check

Package: linkchecker-web
Architecture: all
Depends: linkchecker,
         python,
         ${misc:Depends},
         ${python3:Depends}
Recommends: apache2 | httpd,
            libapache2-mod-wsgi | httpd-wsgi
Description: check websites and HTML documents for broken links (web client)
 Provides a web interface to check links of websites and HTML documents.
 Features:
  * recursive checking
  * multithreaded
  * HTTP/1.1, HTTPS, FTP, mailto:, news:, nntp:, Telnet and local file
    links support
  * proxy support
  * username/password authorization for HTTP, FTP and Telnet
  * robots.txt exclusion protocol support
  * i18n support

## linkchecker 10.0.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # This Makefile is only used by developers.
-PYVER:=2.7
+PYVER:=3
 PYTHON?=python$(PYVER)
 VERSION:=$(shell $(PYTHON) setup.py --version)
 PLATFORM:=$(shell $(PYTHON) -c "from __future__ import print_function; from distutils.util import get_platform; print(get_platform())")
@@ -9,7 +9,7 @@
 LAPPNAME:=$(shell echo $(APPNAME)|tr "[A-Z]" "[a-z]")
 ARCHIVE_SOURCE_EXT:=gz
 ARCHIVE_SOURCE:=$(APPNAME)-$(VERSION).tar.$(ARCHIVE_SOURCE_EXT)
-GITUSER:=wummel
+GITUSER:=linkchecker
 GITREPO:=$(LAPPNAME)
 HOMEPAGE:=$(HOME)/public_html/$(LAPPNAME)-webpage.git
 WEB_META:=doc/web/app.yaml
@@ -34,7 +34,7 @@
 PAGER ?= less
 # options to run the pep8 utility
 PEP8OPTS:=--repeat --ignore=E211,E501,E225,E301,E302,E241 \
-   --exclude="gzip2.py,httplib2.py,robotparser2.py"
+   --exclude="robotparser2.py"
 PY2APPOPTS ?=
 ifeq ($(shell uname),Darwin)
   CHMODMINUSMINUS:=
@@ -53,8 +53,6 @@
 clean:
 	-$(PYTHON) setup.py clean --all
 	rm -f $(LAPPNAME)-out.* *-stamp*
-	$(MAKE) -C linkcheck/HtmlParser clean
-	rm -f linkcheck/network/_network*.so
 	find . -name '*.py[co]' -exec rm -f {} \;
 	find . -name '*.bak' -exec rm -f {} \;
 	find . -depth -name '__pycache__' -exec rm -rf {} \;
@@ -68,18 +66,12 @@
 	rm -rf $(APPNAME)-$(VERSION)
 	rm -rf coverage dist-stamp python-build-stamp*
 
-MANIFEST: MANIFEST.in setup.py
-	$(PYTHON) setup.py sdist --manifest-only
-
 locale:
 	$(MAKE) -C po
 
 # to build in the current directory
-localbuild: MANIFEST locale
-	$(MAKE) -C linkcheck/HtmlParser
+localbuild: locale
 	$(PYTHON) setup.py build
-	cp -f build/lib.$(PLATFORM)-$(PYVER)*/linkcheck/HtmlParser/htmlsax*.so linkcheck/HtmlParser
-	cp -f build/lib.$(PLATFORM)-$(PYVER)*/linkcheck/network/_network*.so linkcheck/network
 
 release: distclean releasecheck filescheck
 	$(MAKE) dist sign register upload homepage tag changelog deb
@@ -127,7 +119,7 @@
 	-chmod -R a+rX,u+w,go-w $(CHMODMINUSMINUS) *
 	find . -type d -exec chmod 755 {} \;
 
-dist: locale MANIFEST chmod
+dist: locale chmod
 	rm -f dist/$(ARCHIVE_SOURCE)
 	$(PYTHON) setup.py sdist --formats=tar
 	gzip --best dist/$(APPNAME)-$(VERSION).tar
@@ -171,7 +163,7 @@
 pyflakes:
 	pyflakes $(PY_FILES_DIRS) 2>&1 | \
           grep -v "local variable 'dummy' is assigned to but never used" | \
-          grep -v -E "'(biplist|setuptools|win32com|find_executable|parse_sitemap|parse_sitemapindex|parse_bookmark_data|parse_bookmark_file|wsgiref|pyftpdlib|linkchecker_rc)' imported but unused" | \
+          grep -v -E "'(setuptools|win32com|find_executable|parse_sitemap|parse_sitemapindex|parse_bookmark_data|parse_bookmark_file|wsgiref|pyftpdlib|linkchecker_rc)' imported but unused" | \
           grep -v "undefined name '_'" | \
 	  grep -v "undefined name '_n'" | cat

=== requirements.txt ===
# required:
beautifulsoup4 >= 4.8.1
requests >= 2.4
pyxdg
dnspython >= 2.0
# optional:
argcomplete

=== doc/Makefile ===
MANFILES:=linkchecker.1 linkcheckerrc.5
LOCALES:=en de

all: html man

code: clean
	PYTHONPATH=.. sphinx-autogen src/code/index.rst

html:
	make -C src html

locale:
	make -C src locale

man:
	make -C src man; \
	make -C src -e SPHINXOPTS="-D language='de' -t de" LANGUAGE="de" man

# check all makefiles for formatting warnings
check:
	@for loc in $(LOCALES); do \
	  for manfile in $(MANFILES); do \
	    echo "Checking man/$$loc/$$manfile"; \
	    LC_ALL=en_US.UTF-8 MANWIDTH=80 mandoc -T lint -W error man/$$loc/$$manfile; \
	  done; \
	done

clean:
	rm -rf src/_build; \
	rm -rf src/code/linkcheck; \
	rm -rf html

.PHONY: check clean html locale man

=== po/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 MSGFMT := msgfmt
 MSGMERGE := msgmerge
 POSOURCES = $(shell find ../linkcheck -name \*.py) \
-	../linkchecker /usr/lib/python2.7/argparse.py
+	../linkchecker $(shell python3 -c 'import argparse; print(argparse.__file__)')
 LDIR = ../share/locale
 PACKAGE = linkchecker
 TEMPLATE = $(PACKAGE).pot
@@ -10,7 +10,7 @@
 LFILE = LC_MESSAGES/$(PACKAGE).mo
 # defined language (add new languages here)
 LANGUAGES = de fr es
-MOFILES = $(wildcard *.po)
+MOFILES = $(wildcard *.mo)
 
 all:	$(MOFILES)
 
@@ -27,12 +27,6 @@
 	  --msgid-bugs-address=$(MYMAIL) -o $(TEMPLATE) \
 	  --keyword=_n:1,2 $(POSOURCES)
 
-%.mo:	%.po
-	if [ ! -d $(LDIR)/$*/LC_MESSAGES ]; then \
-	  mkdir -p $(LDIR)/$*/LC_MESSAGES; \
-	fi
-	$(MSGFMT) -c --statistics -o $(LDIR)/$*/$(LFILE) $<
-
 clean:
 	@for f in $(LANGUAGES); do rm -f $(LDIR)/$$f/$(LFILE); done
 	rm -f *.mo *.bak

=== doc/src/Makefile ===
# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SPHINXINTL    ?= sphinx-intl
SOURCEDIR     = .
BUILDDIR      = _build
LANGUAGE      = en

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

gettext:
	@$(SPHINXBUILD) -b gettext "$(SOURCEDIR)" -d "$(BUILDDIR)/i18n/doctrees" ../i18n/gettext $(SPHINXOPTS) $(O) man/*

html:
	@$(SPHINXBUILD) -b html "$(SOURCEDIR)" -d "$(BUILDDIR)/doctrees" ../html $(SPHINXOPTS) $(O)

man:
	@$(SPHINXBUILD) -b man "$(SOURCEDIR)" -d "$(BUILDDIR)/doctrees" ../man/$(LANGUAGE) $(SPHINXOPTS) $(O)

locale: gettext
	@$(SPHINXINTL) update -p ../i18n/gettext -l de

.PHONY: help gettext html locale man Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
linkchecker (10.0.1-2build1) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Oct 2021 06:56:53 +0000

linkchecker (10.0.1-2) unstable; urgency=medium

  * fix Python3 depends in linkchecker-web (Closes: #966754)

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 09 Mar 2021 09:29:16 -0500

linkchecker (10.0.1-1) unstable; urgency=medium

  * new upstream release, clarifying deps

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 04 Feb 2021 15:23:09 -0500

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,12 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ --with python2
+	dh $@ --with python3
 
 override_dh_auto_configure:
 # make sure docs are generated and the manifest is built
 	$(MAKE) locale
-	python2 setup.py sdist --manifest-only
+	dh_auto_configure --buildsystem pybuild
 
 override_dh_auto_build:
 # force usage of setup.py over Makefile
@@ -50,8 +50,3 @@
 
 # do not run test suite when building
 override_dh_auto_test:
-
-# use xz for debian binary package compression
-override_dh_builddeb:
-	dh_builddeb -- -Zxz
-

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

https://github.com/linkcheck/linkchecker/tags .*/archive/v?((?:\d+\.?)*)\.tar\.gz

## linkchecker 10.1.0

=== po/Makefile ===
XGETTEXT := xgettext
MSGFMT := msgfmt
MSGMERGE := msgmerge
POSOURCES = $(shell find ../linkcheck -name \*.py) \
	$(shell python3 -c 'import argparse; print(argparse.__file__)')
PACKAGE = linkchecker
TEMPLATE = $(PACKAGE).pot
MYMAIL := bastian.kleineidam@web.de
BUGSURL = https://github.com/linkchecker/linkchecker
POFILES = $(wildcard *.po)

all:	$(POFILES)

%.po:	$(TEMPLATE)
	$(MSGMERGE) -U --suffix=.bak $@ $<

template: $(TEMPLATE)
$(TEMPLATE): $(POSOURCES)
	$(XGETTEXT) -w 80 --default-domain=$(PACKAGE) --language=Python \
	  --copyright-holder="Bastian Kleineidam <$(MYMAIL)>" \
	  --package-name=LinkChecker \
	  --msgid-bugs-address=$(BUGSURL) -o $(TEMPLATE) \
	  --keyword=_n:1,2 $(POSOURCES)

check:
	@for po in $(POFILES); do \
		$(MSGFMT) -cv --statistics -o - $$po >/dev/null; \
	done

clean:
	rm -f *.bak

.PHONY: check clean

=== debian/changelog ===
linkchecker (10.1.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on python3-requests.
    + linkchecker: Drop versioned constraint on python3-requests in Depends.
  * Trim trailing whitespace.

  [ Antoine Beaupré ]
  * new upstream release
  * include-binaries: removed, fixed upstream
  * copyright: update date, cleanup missing files
  * watch: follow fork remerge

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 06 Sep 2022 15:49:07 -0400

=== debian/control ===
--- 
+++ 
@@ -2,23 +2,32 @@
 Section: web
 Priority: optional
 Maintainer: Antoine Beaupré <anarcat@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                dh-python,
                gettext,
                python3-all-dev,
-               python3-requests (>= 2.2.1),
+               python3-tomli,
+               python3-packaging,
+               python3-pip,
+               python3-pyparsing,
+               python3-requests,
                python3-setuptools,
+               python3-setuptools-scm,
+               python3-typing-extensions,
                python3-urllib3,
-Standards-Version: 4.1.4
+Standards-Version: 4.1.5
 Homepage: https://linkcheck.github.io/linkchecker/
+Vcs-Git: https://salsa.debian.org/python-team/packages/linkchecker.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/linkchecker
 
 Package: linkchecker
 Architecture: any
 Depends: python3,
-         python3-requests (>= 2.2.1),
+         python3-bs4 (>= 4.8.1),
+         python3-requests,
          python3-urllib3,
          python3-xdg,
-         python3-dnspython,
+         python3-dnspython (>= 2.0),
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
@@ -52,7 +61,7 @@
 Package: linkchecker-web
 Architecture: all
 Depends: linkchecker,
-         python,
+         python3,
          ${misc:Depends},
          ${python3:Depends}
 Recommends: apache2 | httpd,

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

https://github.com/linkchecker/linkchecker/tags .*/archive/v?((?:\d+\.?)*)\.tar\.gz

## linkchecker 10.2.1

=== Makefile ===
# This Makefile is only used by developers.
PAGER ?= less


all:
	@echo "Read the file doc/install.txt to see how to build and install this package."

clean:
	git clean -fdx

locale:
	$(MAKE) -C po

linkcheck/_release.py:
	hatchling build -t sdist --hooks-only

test: linkcheck/_release.py
	tox -e py

upload:
	twine upload dist/LinkChecker*

homepage: linkcheck/_release.py
	make -C doc code
	make -C doc html

dist:
	hatchling build

check:
	flake8
	yamllint .github
	make -C doc check
	make -C po check

releasecheck: check
	@if egrep -i "xx\.|xxxx|\.xx|^[[:digit:]]+\.x" doc/changelog.txt > /dev/null; then \
	  echo "Could not release: edit doc/changelog.txt release date"; false; \
	fi

count:
	@sloccount linkcheck tests


.PHONY: test count upload all clean
.PHONY: locale dist homepage

=== debian/changelog ===
linkchecker (10.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Antoine Beaupré <anarcat@debian.org>  Sun, 29 Jan 2023 21:20:45 -0500

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,15 @@
 Build-Depends: debhelper-compat (= 13),
                dh-python,
                gettext,
+               pybuild-plugin-pyproject,
                python3-all-dev,
+               python3-hatchling,
+               python3-hatch-vcs,
                python3-tomli,
                python3-packaging,
                python3-pip,
                python3-pyparsing,
                python3-requests,
-               python3-setuptools,
-               python3-setuptools-scm,
                python3-typing-extensions,
                python3-urllib3,
 Standards-Version: 4.1.5
@@ -26,7 +27,6 @@
          python3-bs4 (>= 4.8.1),
          python3-requests,
          python3-urllib3,
-         python3-xdg,
          python3-dnspython (>= 2.0),
          ${misc:Depends},
          ${python3:Depends},

## linkchecker 10.3.0

=== debian/changelog ===
linkchecker (10.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 19 Sep 2023 09:57:07 -0400

## linkchecker 10.4.0

=== doc/src/Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # You can set these variables from the command line, and also
 # from the environment for the first two.
-SPHINXOPTS    ?=
-SPHINXBUILD   ?= sphinx-build
-SPHINXINTL    ?= sphinx-intl
+SPHINXOPTS    ?= -W --keep-going
+SPHINXBUILD   ?= python3 -m sphinx.cmd.build
+SPHINXINTL    ?= python3 -m sphinx_intl.commands
 SOURCEDIR     = .
 BUILDDIR      = _build
 LANGUAGE      = en
@@ -12,7 +12,7 @@
 	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
 
 gettext:
-	@$(SPHINXBUILD) -b gettext "$(SOURCEDIR)" -d "$(BUILDDIR)/i18n/doctrees" ../i18n/gettext $(SPHINXOPTS) $(O) man/*
+	@$(SPHINXBUILD) -b gettext "$(SOURCEDIR)" -d "$(BUILDDIR)/i18n/doctrees" ../i18n/gettext man/* $(SPHINXOPTS) $(O)
 
 html:
 	@$(SPHINXBUILD) -b html "$(SOURCEDIR)" -d "$(BUILDDIR)/doctrees" ../html $(SPHINXOPTS) $(O)

=== debian/changelog ===
linkchecker (10.4.0-1) unstable; urgency=medium

  * New upstream release (Closes: #1030006)
  * Fix mod-wsgi dependency (Closes: #1037294)

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 12 Dec 2023 11:08:41 -0500

## linkchecker 10.5.0

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,6 @@
 	twine upload dist/LinkChecker*
 
 homepage: linkcheck/_release.py
-	make -C doc code
 	make -C doc html
 
 dist:

=== doc/Makefile ===
--- 
+++ 
@@ -3,10 +3,7 @@
 
 all: html man
 
-code: clean
-	PYTHONPATH=.. sphinx-autogen src/code/index.rst
-
-html:
+html: clean
 	make -C src html
 
 locale:
@@ -16,7 +13,7 @@
 	make -C src man; \
 	make -C src -e SPHINXOPTS="-D language='de' -t de" LANGUAGE="de" man
 
-# check all makefiles for formatting warnings
+# check all man files for formatting warnings
 check:
 	@for loc in $(LOCALES); do \
 	  for manfile in $(MANFILES); do \

=== debian/changelog ===
linkchecker (10.5.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop python3-tomli from build-dependencies

 -- Alexandre Detiste <tchet@debian.org>  Sat, 26 Jul 2025 01:50:03 +0200

linkchecker (10.5.0-1) unstable; urgency=medium

  * New upstream release

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 27 Nov 2024 13:58:46 -0500

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
                python3-all-dev,
                python3-hatchling,
                python3-hatch-vcs,
-               python3-tomli,
                python3-packaging,
                python3-pip,
                python3-pyparsing,
@@ -65,7 +64,7 @@
          ${misc:Depends},
          ${python3:Depends}
 Recommends: apache2 | httpd,
-            libapache2-mod-wsgi | httpd-wsgi
+            libapache2-mod-wsgi-py3 | httpd-wsgi
 Description: check websites and HTML documents for broken links (web client)
  Provides a web interface to check links of websites and HTML documents.
  Features:

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/pkg-info.mk
+export SETUPTOOLS_SCM_PRETEND_VERSION=$(DEB_VERSION_UPSTREAM)
 
 %:
 	dh $@ --with python3
@@ -45,7 +48,11 @@
 	install -m 644 config/linkchecker.apache2.conf $(ETCDIRWEB)/apache2/conf-available/linkchecker-web.conf
 
 # clean generated files
-override_dh_clean:
+#
+# this also skips the upstream `make clean` target which shells out to
+# git instead of properly cleaning up its own files
+override_dh_auto_clean:
+	dh_auto_clean --buildsystem pybuild
 	dh_clean doc/html/*.qch doc/html/*.qhc _LinkChecker_configdata.py
 
 # do not run test suite when building

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
      https://github.com/linkchecker/linkchecker/tags \
      (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## linkchecker 10.6.0

=== debian/changelog ===
linkchecker (10.6.0-2) unstable; urgency=medium

  * acknowledge silent NMU from tchet, notified him by email

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 05 Feb 2026 10:34:21 -0500

linkchecker (10.6.0-1) unstable; urgency=medium

  * New upstream release

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 05 Feb 2026 10:23:17 -0500
